this.name           = "realisticDamage.js";
this.author         = "Thargoid";
this.copyright      = "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description    = "Chance for damaged equipment to be totally destroyed";
this.version        = "1.00";

this.startUp = function()
	{ this.scriptDelay = new Timer(this, this.$scanScripts, 0.25); }

this.$scanScripts = function()
	{ // delay of 0.25s to ensure all worldscripts are loaded before scanning
	this.scriptArray = []; // array of loaded worldscripts which contain equipmentDestroyed function
	this.damagedArray = []; // array of damaged equipment to be checked for destruction
	if(worldScriptNames.length > 0)
		{
		var scriptCounter = 0 ; // reset the counter
		for(scriptCounter = 0;scriptCounter<worldScriptNames.length;scriptCounter++)
			{
			if(worldScriptNames[scriptCounter] && worldScripts[worldScriptNames[scriptCounter]] && worldScripts[worldScriptNames[scriptCounter]].equipmentDestroyed)
				{ this.scriptArray.push(worldScriptNames[scriptCounter]); }
			}
		}
	}

this.shipWillLaunchFromStation = function(station)
	{ this.itemCounter = 0; }
	
this.equipmentDamaged = function(equipment) 
	{
	this.damagedArray.push(equipment);
	this["checkDelay"+(this.itemCounter++)] = new Timer(this, this.$checkEquipment, 0.25); 
	// unique timer ID for each item, in case of multiple concurrent damages
	}

this.$checkEquipment = function()
	{	
	if(!this.damagedArray || this.damagedArray.length === 0)	{ return; }
	this.damagedEquipment = this.damagedArray.pop();
	if(player.ship.equipmentStatus(this.damagedEquipment) !== "EQUIPMENT_DAMAGED") { return; }
	this.equipmentItem = EquipmentInfo.infoForKey(this.damagedEquipment);
	this.equipLevel = this.equipmentItem.effectiveTechLevel;
	this.chance = 0.05 + (0.05 * Math.random()) + ((this.equipLevel - 7) * 0.01);
	if(Math.random() < this.chance)
		{
		this.link = (this.equipmentItem.name.length > 1 && this.equipmentItem.name.charAt(this.equipmentItem.name.length-1) === "s" && this.equipmentItem.name.charAt(this.equipmentItem.name.length-2) !== "s") ? " have " : " has ";
		player.consoleMessage(this.equipmentItem.name + this.link + "been destroyed!");
		player.ship.removeEquipment(this.equipmentItem);
		if(this.scriptArray && this.scriptArray.length > 0)
			{
			var scriptCounter = 0 ; // reset the counter
			for(scriptCounter = 0;scriptCounter<this.scriptArray.length;scriptCounter++)
				{ worldScripts[this.scriptArray[scriptCounter]].equipmentDestroyed(this.damagedEquipment); }
			}
		}
	}
